! ======================================================================
! Vectores de progresiones geometricas
! x(i)=r**i, y(i)=s**i, p=<x,y>, rs=1/2, p=1-1/2**n
! ======================================================================

PROGRAM blas1_1
IMPLICIT NONE

INTEGER, PARAMETER:: nmax=100, nsal=11
REAL(KIND(0.d0)):: x(nmax), y(nmax)
REAL(KIND(0.d0)), PARAMETER:: d=0.3d0
REAL(KIND(0.d0)):: r, s, pexacto, pef90, peblas
REAL(KIND(0.d0)), EXTERNAL:: ddot
INTEGER n, i

OPEN (nsal,FILE='BLAS1-1.sal')

! Progresiones geometricas

r = 1.d0/(2.d0+d) ; s = (2.d0+d)/2.d0
DO i = 1, nmax
  x(i) = r**i ; y(i) = s**i
ENDDO

DO n = 1, nmax
  pexacto = 1.d0 - 0.5d0**n
  pef90 = DOT_PRODUCT(x(:n),y(:n))
  peblas = ddot(n, x, 1, y, 1)
  WRITE (nsal,'(/A,I4,T10,A,G25.17)') 'n = ', n, 'exacto = ', pexacto
  WRITE (nsal,'(T10,A,G25.17)') 'pef90  = ', pef90, 'peBLAS = ', peblas
ENDDO

ENDPROGRAM blas1_1