! ======================================================================
! Adaptacion de rango 2 para matrices simetricas

! Datos: matriz A simetrica, vectores x, y, factor alfa
! Calculos: A = A + alfa*xy' + alfa*yx', permite subindices espaciados
! ======================================================================

PROGRAM blas2_ssyr2
IMPLICIT NONE

INTEGER, PARAMETER:: n=4, nsal=11
REAL a(n,n), x(n,1), y(1,n), alfa
INTEGER incx, incy, i
CHARACTER uplo

OPEN (nsal,FILE='BLAS2-SSYR2.sal')

a = RESHAPE ((/1,2,3,4, 2,5,6,7, 3,6,8,9, 4,7,9,10/), (/4,4/))
x(:,1) = (/ -1, -2, -3, -4 /)
y(1,:) = (/ 6, 5, 4, 3 /)
uplo = 'L'
alfa = 1.0
incx = 1 ; incy = 1

CALL ssyr2 (uplo, n, alfa, x(:,1), incx, y(1,:), incy, a, n)
WRITE (nsal,'(A)') 'a (BLAS): '
DO i = 1, n ; WRITE (nsal,'(4F10.3)') a(i,1:i) ; ENDDO

! Fortran 90 estandar

a = RESHAPE ((/1,2,3,4, 2,5,6,7, 3,6,8,9, 4,7,9,10/), (/4,4/))

a = a + alfa*MATMUL(x,y) + alfa*MATMUL(TRANSPOSE(y),TRANSPOSE(x))
WRITE (nsal,'(/A)') 'a (F90): '
DO i = 1, n ; WRITE (nsal,'(4F10.3)') a(i,1:i) ; ENDDO

ENDPROGRAM blas2_ssyr2
