! ======================================================================
! Resuelve sistemas lineales triangulares con lado derecho multiple

! Datos: matriz A triangular, matriz B (lado derecho), factor alfa
! Opciones: side, uplo, transA, diag
! Calculos: en B(m,n) devuelve X tal que:
!   AX=alfa*B , si side='L', transA='N' con A(m,m)
!   A'X=alfa*B, si side='L', transA='T' con A(m,m)
!   XA=alfa*B , si side='R', transA='N' con A(n,n)
!   XA'=alfa*B, si side='R', transA='T' con A(n,n)
! ======================================================================

PROGRAM blas3_strsm
IMPLICIT NONE

INTEGER, PARAMETER:: m=3, n=4, nsal=11
REAL a(m,m), b(m,n), alfa
CHARACTER side, uplo, transA, diag
INTEGER i

OPEN (nsal,FILE='BLAS3-STRSM.sal')

a = RESHAPE ((/1,0,0, 1,2,0, 2,-1,5/), (/3,3/))
b = RESHAPE ((/1,2,-1, 0,1,0, 1,3,4, -1,0,2/), (/3,4/))
side = 'L' ; uplo = 'U' ; transA = 'N' ; diag = 'N'
alfa = 1.d0

CALL strsm (side, uplo, transA, diag, m, n, alfa, a, m, b, m)
WRITE (nsal,'(4(3X,A,I2))') ('Sistema',i,i=1,n)
DO i = 1, m ; WRITE (nsal,'(4F12.3)') b(i,:) ; ENDDO

ENDPROGRAM blas3_strsm